//page transition function
var flag = false;

var show = {
    forward: {
        p: { opacity: [1, 0],/* translateX: [ 0, "100%" ],*/ translateZ: 0 },
        o: { duration: 250, display: 'block' }
    },
    back: {
        p: { opacity: [1, 0],/* translateX: [ 0, "-100%" ],*/ translateZ: 0 },
        o: { duration: 250, display: 'block' }
    }
};

var showFlex = {
    forward: {
        p: { opacity: [1, 0],/* translateX: [ 0, "100%" ],*/ translateZ: 0 },
        o: { duration: 150, display: 'flex' }
    },
    back: {
        p: { opacity: [1, 0],/* translateX: [ 0, "-100%" ],*/ translateZ: 0 },
        o: { duration: 150, display: 'flex' }
    }
};

var hide = {
    forward: {
        p: { opacity: [0, 1],/* translateX: [ "-100%", 0 ],*/ translateZ: 0 },
        o: { duration: 150, display: 'none' }
    },
    back: {
        p: { opacity: [0, 1],/* translateX: [ "100%", 0 ],*/ translateZ: 0 },
        o: { duration: 150, display: 'none' }
    }
};

function addFormToString(formName) {
    if (data === undefined) {
        data = "";
    }
    data += BuildResult(this.document, formName);
    console.log(data);
}

function buttonClick(ID, executeFxn) {
    $(ID).on('click', function (e) {
        e.stopPropagation(); e.preventDefault();
        e.target.disabled = true;

        executeFxn();

        $(ID).addClass('push');
        $(ID).one('webkitAnimationEnd animationend', function () {
            $(ID).removeClass('push');
            setTimeout(function () {
                e.target.disabled = false;
            }, 1000);
        });

    });
}

function clearVehicleInfo() {
    if (document.getElementById('noVehicle').checked === true) {
        document.getElementById('mz_primaryYear').value = "";
        document.getElementById('mz_primaryMake').value = "";
        document.getElementById('mz_primaryModel').value = "";
    }
};

function closeRulesModal() {
    $('#sweepsRulesModal').hide();
}

function End() {
    console.log("call End");
}

function GetStateID(abb) {
    console.log("GetStateID");
    app.model.state = abb;
    if (app.model.state === 5 || app.model.state === "5") {
        app.model.state = "CA";
    }
    if (abb == 'AL')
        return 1;
    if (abb == "AK")
        return 2;
    if (abb == "AZ")
        return 3;
    if (abb == "AR")
        return 4;
    if (abb == "CA")
        return 5;
    if (abb == "CO")
        return 6;
    if (abb == "CT")
        return 7;
    if (abb == "DE")
        return 8;
    if (abb == "FL")
        return 9;
    if (abb == "GA")
        return 10;
    if (abb == "HI")
        return 11;
    if (abb == "ID")
        return 12;
    if (abb == "IL")
        return 13;
    if (abb == "IN")
        return 14;
    if (abb == "IA")
        return 15;
    if (abb == "KS")
        return 16;
    if (abb == "KY")
        return 17;
    if (abb == "LA")
        return 18;
    if (abb == "ME")
        return 19;
    if (abb == "MD")
        return 20;
    if (abb == "MA")
        return 21;
    if (abb == "MI")
        return 22;
    if (abb == "MN")
        return 23;
    if (abb == "MS")
        return 24;
    if (abb == "MO")
        return 25;
    if (abb == "MT")
        return 26;
    if (abb == "NE")
        return 27;
    if (abb == "NV")
        return 28;
    if (abb == "NH")
        return 29;
    if (abb == "NJ")
        return 30;
    if (abb == "NM")
        return 31;
    if (abb == "NY")
        return 32;
    if (abb == "NC")
        return 33;
    if (abb == "ND")
        return 34;
    if (abb == "OH")
        return 35;
    if (abb == "OK")
        return 36;
    if (abb == "OR")
        return 37;
    if (abb == "PA")
        return 38;
    if (abb == "RI")
        return 39;
    if (abb == "SC")
        return 40;
    if (abb == "SD")
        return 41;
    if (abb == "TN")
        return 42;
    if (abb == "TX")
        return 43;
    if (abb == "UT")
        return 44;
    if (abb == "VT")
        return 45;
    if (abb == "VA")
        return 46;
    if (abb == "WA")
        return 47;
    if (abb == "WV")
        return 48;
    if (abb == "WI")
        return 49;
    if (abb == "WY")
        return 50;
    if (abb == "DC")
        return 51;
    if (abb == "PR")
        return 52;
    if (abb == "VI")
        return 53;
}

function fieldToggle(ID, showHide, clear, clearField) {
    if (showHide === 'show') {
        $('#' + ID).removeClass('hide');
        if (ID === 'phoneContactWrap') {
            document.getElementById('mz_Mobile2').value = document.getElementById('mz_Mobile').value;
        }
    } else if (showHide === 'hide') {
        $('#' + ID).addClass('hide');
    }
    if (clear === true) {
        document.getElementById(clearField).value = "";
    }
};

function isInArray(value, array) {
    return array.indexOf(value) > -1;
}

function showHideView(objHide, objShow, direction) {
    window.scrollTo(0, 0);
    if (!flag) {
        flag = true;

        if (direction === 'forward') {
            objHide.velocity(hide.forward.p, hide.forward.o);
            objShow.velocity(show.forward.p, show.forward.o);
        }

        if (direction === 'back') {
            objHide.velocity(hide.back.p, hide.back.o);
            objShow.velocity(show.back.p, show.back.o);
        }

        var flagTimer = setTimeout(function () {
            clearTimeout(flagTimer);
            flag = false;
        }, 600)

    }
};

function showHideFLEX(objHide, objShow, direction) {
    window.scrollTo(0, 0);
    if (!flag) {
        flag = true;

        if (direction === 'forward') {
            objHide.velocity(hide.forward.p, hide.forward.o);
            objShow.velocity(showFlex.forward.p, showFlex.forward.o);
        }

        if (direction === 'back') {
            objHide.velocity(hide.back.p, hide.back.o);
            objShow.velocity(showFlex.back.p, showFlex.back.o);
        }

        var flagTimer = setTimeout(function () {
            clearTimeout(flagTimer);
            flag = false;
        }, 600)
    }
};

function valOptIn(id) {
    var getOptIn = document.getElementById(id);
    var info = getOptIn.getElementsByTagName('input');
    var i;
    for (i = 0; i < info.length; ++i) {
        if (info[i].checked) {
            $('#' + id).removeClass('invalid');
            return true;
        }
    }//loop group
    $('#' + id).addClass('invalid');

    return false;
}//validate radios or checkboxes

function surveyQuestionsValidate() {
    console.log(arguments)
    var returnVariables = [];

    for (var i = 0; i < arguments.length; i++) {
        returnVariables[i] = valOptIn(arguments[i]);
    }

    function elementValidateTrue(element) {
        return element === true;
    }

    return returnVariables.every(elementValidateTrue);

}

function buildChecks(which, checkID) {
    var gatherMethod = '';
    var counter = 0;
    var getBox = document.getElementById(which);
    var getInputsBox = getBox.getElementsByTagName('input');

    for (var i = 0; i < getInputsBox.length; i++) {

        if (getInputsBox[i].type == 'checkbox' && getInputsBox[i].checked) {
            counter++;
            gatherMethod += checkID + counter + "=" + getInputsBox[i].value + ';';
        }

    }

    return gatherMethod;
}//buildChecks

function MZvalidStyle() {
    $("input, select").each(function () {
        var id = $(this).attr('id');
        $(this).attr("data-json-override-invalid", "{'elemId':'" + id + "','invalidcss':'2px solid #e63312','validcss':'2px solid #bdbdbd','property':'border'}")
    });

};

function VerifyAge(dob, minAge, maxAge, ageStop) {
    var today = new Date();
    var birthDate = new Date(dob);
    var age = today.getFullYear() - birthDate.getFullYear();
    var m = today.getMonth() - birthDate.getMonth();
    if (m < 0 || (m === 0 && today.getDate() < birthDate.getDate())) {
        age--;
    }

    return age;
}

function replaceState() {
    var updatedState = GetStateID($('#State').val());

    var stateVal = "State=" + $('#State').val() + ";";

    var updatedData = data.replace(stateVal, updatedState);

    data = updatedData;
}

function replaceArrayValue(original, updated) {
    var index = selectedVOIs.indexOf(original);

    if (index !== -1) {
        selectedVOIs[index] = updated;
    }
}

function openRulesModal() {
    $('#sweepsRulesModal').show();
}

function openMultiRulesModal() {
    $('#multiSweepsRulesModal').show();
}

function closeMultiRulesModal() {
    $('#multiSweepsRulesModal').hide();
}

function setLanguage(selection) {
    language = selection;
    console.log(language);
}

function AppendDDLToEM(str, obj, fld, ed) {
    var ed = ed;
    var val = obj.options[obj.selectedIndex].value;
    var arrEM = [document.getElementById(fld)];
    if (arrEM.length === 1) {
        var ems = arrEM[0].value.split(',');
        var em = ems.length > 0 ? ems[ems.length - 1] : "";
        var li = em.lastIndexOf(str) == -1 ? em.length : em.lastIndexOf(str);
        li = (li < em.lastIndexOf('@') || em.lastIndexOf('@') == -1) && em.substring(em.length - 1) != str ? em.length : li;
        em = em.substring(0, li) + val;
        var emails = "";
        for (var i = 0; i < ems.length - 1; i++) {
            if (i > 0)
                emails += ",";

            emails += ems[i];
        }
        if (emails.length > 0)
            em = emails + "," + em;
        arrEM[0].value = em;

        //****************************************
        //some tablets needs this to work properly
        arrEM[0].blur();
        //****************************************
    }
    rebuildDDLEMDomain(ed);
}

function rebuildDDLEMDomain(ed) {
    var ed = ed;

    var arr = new Array("@", "", "@gmail.com", "@gmail.com", "@yahoo.com", "@yahoo.com", "@hotmail.com", "@hotmail.com", "@aol.com", "@aol.com", "@msn.com", "@msn.com");
    $('#' + ed).empty();

    for (var i = 0; i < arr.length; i = i + 2) {
        addOption2(arr[i], arr[i + 1], i == 0, ed);
    }
    document.getElementById(ed).options[0].disabled = true;
}

function addOption2(textString, valueSetting, currentValue, ed) {
    $('#' + ed).append($('<option>', {
        value: valueSetting,
        text: textString,
        selected: currentValue
    }));
}

function advance() {
    console.log("ADVANCE");
    window.scrollTo(0, 0);
    const activeWrapper = $(".wrapper_active");
    const nextWrapper = activeWrapper.nextAll(".wrapper")[0];

    activeWrapper.removeClass("wrapper_active");
    nextWrapper.classList.add("wrapper_active");

    window.scrollTo(0, 0);
}

// Tweak BuildResult function to collect DATA-ID attribute value(as a key in result string) instead of an ID attribute.
function BuildResult(document, formName) {
    console.log("UPDATED BUILD RESULT")
    var result = '';
    var elems = document.getElementById(formName).elements;

    for (var i = 0; i < elems.length; i++) {
        var e = elems[i];
        var attr = e.hasAttribute("data-id") ? "data-id" : "id";
        var eID = e.getAttribute(attr);
        if (eID != 'EmailDomain' && eID != 'Domain' && eID.substring(0, 3) != "mz_") {
            if (e.type == "text" || e.type == "textarea" || e.type == "number" || e.type == "tel" || e.type == "email") {
                if (e.value.trim() != '')
                    result += eID + "=" + encodeForiOS(e.value) + ";"
            } else if (e.type == "select-one") {
                if (e.options.length > 0 && e.options[e.selectedIndex].value.trim() != '')
                    result += eID + "=" + encodeForiOS(e.options[e.selectedIndex].value) + ";"
            } else if (e.type == "checkbox") {
                result += eID + "=";
                if (e.checked) {
                    result += "Yes;";
                } else {
                    result += "No;"
                }
            } else if (e.type == "radio" && e.checked) {
                result += eID + "=";
                result += encodeForiOS(e.value) + ";"
            } else if (e.type == "hidden") {
                result += eID + "=";
                result += encodeForiOS(e.value) + ";"
            }
        }
    }
    return result;
}